#!/usr/bin/wish


#    Copyright 2003 Regis Damongeot

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#window title
wm title . "TkDVD 2.2"
set burn_type "burn_dvd"
set burning_device "/dev/sr0"
set burn_command "growisofs"
set volume_id ""
set volume_id_o ""
set option_joliet_ext "-J"
set option_rr_ext ""
set option_rra_ext "-r"
set option_pad "-pad"
set file_list ""
set excluded_file_list ""
set only_one_file ""
set input ""
set total_file_size_f "0 Ko"
set space_left_f "4,377 Go"
set selected_directory "[pwd]"
set iso_file ""
set t_session "-Z"
set option_dvd_compat "-dvd-compat"
set option_overburn ""
set command_line "growisofs $t_session $burning_device $option_joliet_ext $option_rr_ext $option_rra_ext $option_dvd_compat $option_pad -graft-points"
#needed to not have too large precision when show total files size
set tcl_precision 4

#source of the total file size count procedure
source src/proc_total_file_size.tcl
#source of the refresh command line procedure (main procedure)
source src/proc_refresh_cmd_line.tcl
#source of excluded file window and its needed procedures
source src/excluded_file_window.tcl

#Create frame for burn type
frame .frame_burn_type -background #f5f5f5
pack .frame_burn_type -fill x
radiobutton .frame_burn_type.burn_dvd -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Burn a DVD" -command burn_dvd_proc -variable burn_type -value burn_dvd
.frame_burn_type.burn_dvd select
radiobutton .frame_burn_type.create_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Only create iso9660 image" -command { create_iso_proc } -variable burn_type -value create_iso
radiobutton .frame_burn_type.burn_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Burn iso9660 image" -command { burn_iso_proc } -variable burn_type -value burn_iso
button  .frame_burn_type.open_iso -highlightbackground red -text "Open" -state disabled -command choose_iso_file
entry .frame_burn_type.iso_file -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable iso_file -width 35
pack .frame_burn_type.burn_dvd .frame_burn_type.create_iso .frame_burn_type.burn_iso .frame_burn_type.open_iso .frame_burn_type.iso_file -side left

# create frame for command line and burning device
frame .frame_command_line -background #f5f5f5
pack .frame_command_line -fill x
label .frame_command_line.label_b_device -bg #f5f5f5 -text "Burning device:"
entry .frame_command_line.b_device -relief flat -bg white -highlightbackground blue -highlightcolor blue -disabledbackground #f5f5f5 -state normal -textvariable burning_device
entry .frame_command_line.cmd_line -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable command_line -width 50
button .frame_command_line.go_button -text "Burn" -command { refresh_cmd_line; Launch }
pack .frame_command_line.label_b_device .frame_command_line.b_device .frame_command_line.cmd_line .frame_command_line.go_button -side left

#frame for volume id, app id, etc
frame .volume_id -background #f5f5f5
pack .volume_id -fill x
label .volume_id.label_vid -bg #f5f5f5 -text "Volume ID:"
entry .volume_id.volume_id -relief flat -bg white -highlightbackground blue -highlightcolor blue  -disabledbackground #f5f5f5 -state normal -textvariable volume_id_o
label .volume_id.label_file_size -bg #f5f5f5 -text "Total Used Space:"
entry .volume_id.show_file_size -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable total_file_size_f -width 10
label .volume_id.label_space_left -bg #f5f5f5 -text "Space Left:"
entry .volume_id.show_space_left -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable space_left_f -width 10
pack .volume_id.label_vid .volume_id.volume_id .volume_id.label_file_size .volume_id.show_file_size .volume_id.label_space_left .volume_id.show_space_left -side left

#create frame for options buttons
frame .options_top -background #f5f5f5
frame .options_middle -background #f5f5f5
frame .options_bottom -background #f5f5f5
pack .options_top -fill x
pack .options_middle -fill x
pack .options_bottom -fill x
checkbutton .options_top.joliet_ext -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "add Joliet extensions (-J)" -variable option_joliet_ext -offvalue "" -onvalue "-J" -command refresh_cmd_line
checkbutton .options_top.rr_ext -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "add Rock Ridge extensions (-R)" -variable option_rr_ext -offvalue "" -onvalue "-R"  -command refresh_cmd_line
checkbutton .options_top.pad -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "pad (Highly Recommanded) (-pad)" -variable option_pad -offvalue "" -onvalue "-pad"  -command refresh_cmd_line
checkbutton .options_middle.rra_ext -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "add anonymous Rock Ridge extensions (all files set to r--r--r-- or +x if executable) (-r)" -variable option_rra_ext -offvalue "" -onvalue "-r" -command refresh_cmd_line
checkbutton .options_middle.overburn -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "Overburn (-overburn)" -variable option_overburn -offvalue "" -onvalue "-overburn" -command refresh_cmd_line
checkbutton .options_bottom.multisession -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "Add session to disc (-M)" -variable t_session -offvalue "-Z" -onvalue "-M"  -command refresh_cmd_line
checkbutton .options_bottom.monosession -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "Maximum media compatibility (if DVD R => create single session closed disc) (-dvd-compat)" -variable option_dvd_compat -offvalue "" -onvalue "-dvd-compat"  -command refresh_cmd_line
pack .options_top.joliet_ext .options_top.rr_ext .options_middle.rra_ext .options_middle.overburn .options_top.pad  -side left
pack .options_bottom.multisession .options_bottom.monosession -side left

#create frame for file manipulations
frame .files_manipulations -background #f5f5f5
pack .files_manipulations  -fill x
button .files_manipulations.add -highlightbackground red -text "Add files" -command { if { [catch { .file_selection.open cget -state }] } { create_file_list [FileOpen $selected_directory] } }
button .files_manipulations.add_d -highlightbackground red -text "Add Directory" -command add_d
button .files_manipulations.delete -highlightbackground red -text "Delete file/directory" -command delete_files
button .files_manipulations.clear -highlightbackground red -text "Clear list" -command { set file_list ""; refresh_total_file_size; refresh_cmd_line }
button .files_manipulations.excluded_files -highlightbackground red -text "Excluded file/dir list" -command { excluded_file_window }

pack .files_manipulations.add .files_manipulations.add_d .files_manipulations.delete .files_manipulations.clear .files_manipulations.excluded_files -side left

#create frame for file list
frame .file_list
listbox .file_list.list -bg #f5f5f5 -listvariable file_list -heigh 15 -yscrollcommand { .file_list.scroll_bar set }
scrollbar .file_list.scroll_bar -command { .file_list.list yview }
pack .file_list -fill both -expand false
pack .file_list.scroll_bar -side right -fill y
pack .file_list.list -fill x

#create output frame
frame .output
text .output.log -heigh 10 -bg #f5f5f5 -relief ridge -setgrid true -yscrollcommand { .output.scroll_bar set }
scrollbar .output.scroll_bar -command { .output.log yview }
pack .output.scroll_bar -side right -fill y
pack .output.log -side left -fill both -expand true
pack .output -fill both -expand true

#beginning of the procedure part

proc file_list_w_modif_dir { file_list_to_modif } {
	puts "$file_list_to_modif"
	set file_list_to_modif_f ""
	#set modified false
	for { set i 0 } { $i < [llength $file_list_to_modif]} { incr i } {
		if { [file isdirectory [lindex $file_list_to_modif $i]] } {
			set file_list_to_modif [lreplace $file_list_to_modif $i $i "[lindex [split [lindex $file_list_to_modif $i] /] end]/=[lindex $file_list_to_modif $i]"]
		} else {
		}
	}
	#if { $modified == true } { return [eval concat $file_list_to_modif] } else { return $file_list_to_modif }
	return $file_list_to_modif
}

#validatecommand must be after the called proc
.frame_command_line.b_device configure -validate focus -validatecommand refresh_cmd_line

proc choose_iso_file {} {
	global iso_file burn_type burning_device
	set iso_file_o ""
	if { $burn_type == "burn_iso" } {
		set iso_file_o [tk_getOpenFile -defaultextension .iso -title "Select ISO Image"]
		if { [llength $iso_file_o] > 1} {
			set iso_file [lindex $iso_file_o 0]
			for { set i 1} {$i < [llength $iso_file_o]} {incr i} {
				set iso_file "$iso_file\\ [lindex $iso_file_o $i]"
			}
		} else {
			set iso_file $iso_file_o
		}
	} else {
		set burning_device ""
		set iso_file [tk_chooseDirectory -mustexist 0]
		set burning_device "-o"
		lappend burning_device $iso_file
	}
	refresh_cmd_line
}

proc check_volume_id {} {
	global volume_id volume_id_o
	set volume_id ""
	if { $volume_id_o == "" } {
		set volume_id ""
	} elseif { [llength $volume_id_o] > 1} {
			set volume_id [lindex $volume_id_o 0]
			for { set i 1} {$i < [llength $volume_id_o]} {incr i} {
				set volume_id "$volume_id\\ [lindex $volume_id_o $i]"
			}
			set volume_id "-V $volume_id"
		} else { set volume_id "-V $volume_id_o" }
}

proc create_file_list { file } {
	global file_list only_one_file
	#mis a 1 o moment de la selection des fichiers, pose pb si on utilise concat car un  fichier avec d espaces sera considere comme plusieurs fichiers
	if { $only_one_file == 1 } {
		lappend file_list $file
	} else {
	#ds le cas contraire (multiple selection) on utilise concact pour eviter davoir tout sur la meme ligne (1 seul element)
		set file_list [concat $file_list $file]
	}
	set only_one_file 0
	#refresh command line entry after checking space used to check overburn condition
	refresh_total_file_size
	refresh_cmd_line
	
}

proc add_d {} {
	global file_list
	set temp [tk_chooseDirectory]
	set temp_f "[lindex $temp 0]"
	if { $temp != "" } {
		#for {set i 1} { $i < [llength $temp] } {incr i} {
		#	append temp_f "\\ [lindex $temp $i]"
		#}
		lappend file_list $temp
		#refresh command line entry after checking space used to check overburn condition
		refresh_total_file_size
		refresh_cmd_line
	}
}

proc delete_files {} {
	global file_list
	#puts $file_list
	#puts [.file_list.list curselection]
	if { "[.file_list.list curselection]" == "" } {
	} else {
		set file_list [lreplace $file_list [.file_list.list curselection] [.file_list.list curselection]]
		#refresh command line entry after checking space used to check overburn condition
		refresh_total_file_size
		refresh_cmd_line
	}
	#lreplace file_list 0 end
	#lset file_list [concat $file_list]
	#puts [llength $file_list]
}

proc Launch {} {
	global input command_line
	if [catch {open "|$command_line |& cat"} input] {
		.output.log insert end $command_line\n
	} else {
		fileevent $input readable log_proc
		.output.log insert end "$command_line\n"
	}
}

proc log_proc {} {
	global input
	if [eof $input] {
		catch { close $input }
	} else {
		gets $input line
		.output.log insert end $line\n
		.output.log see end
	}
}

proc burn_iso_proc {} {
	global burn_command t_session burning_device option_dvd_compat option_overburn
	set burn_command "growisofs"
	set t_session "-Z"
	set option_dvd_compat ""
	set option_overburn ""
	set burning_device "/dev/sr0"
	.frame_burn_type.open_iso configure -state normal
	.volume_id.label_vid configure -state disabled
	.volume_id.volume_id configure -state disabled
	.files_manipulations.add configure -state disabled
	.files_manipulations.add_d configure -state disabled
	.files_manipulations.delete configure -state disabled
	.files_manipulations.clear configure -state disabled
	.files_manipulations.excluded_files configure -state disabled
	.options_top.pad configure -state disabled
	.options_middle.rra_ext configure -state disabled
	.options_top.rr_ext configure -state disabled
	.options_top.joliet_ext configure -state disabled
	.options_middle.overburn configure -state normal
	.options_bottom.multisession configure -state normal
	.options_bottom.monosession configure -state normal
	.volume_id.label_file_size configure -state disabled
	.frame_command_line.b_device configure -state normal
	set volume_id ""
	set volume_id_o ""
	set option_joliet_ext ""
	set option_rr_ext ""
	set option_rra_ext ""
	set option_pad ""
	refresh_cmd_line
}

proc burn_dvd_proc {} {
	global burn_command t_session burning_device option_dvd_compat option_overburn
	set burn_command "growisofs"
	set t_session "-Z"
	set option_dvd_compat ""
	set option_overburn ""
	set burning_device "/dev/sr0"
	.frame_burn_type.open_iso configure -state disabled
	.volume_id.label_vid configure -state normal
	.volume_id.volume_id configure -state normal
	.files_manipulations.add configure -state normal
	.files_manipulations.add_d configure -state normal
	.files_manipulations.delete configure -state normal
	.files_manipulations.clear configure -state normal
	.files_manipulations.excluded_files configure -state normal
	.options_top.pad configure -state normal
	.options_middle.rra_ext configure -state normal
	.options_top.rr_ext configure -state normal
	.options_top.joliet_ext configure -state normal
	.options_middle.overburn configure -state normal
	.options_bottom.multisession configure -state normal
	.options_bottom.monosession configure -state normal
	.volume_id.label_file_size configure -state normal
	.frame_command_line.b_device configure -state normal
	refresh_cmd_line
}

proc create_iso_proc {} {
	global burn_command t_session burning_device option_dvd_compat option_overburn
	burn_dvd_proc
	.options_middle.overburn configure -state disable
	.options_bottom.multisession configure -state disabled
	.options_bottom.monosession configure -state disabled
	.frame_burn_type.open_iso configure -state normal
	.frame_command_line.b_device configure -state disabled
	set burn_command "mkisofs"
	set t_session ""
	set option_dvd_compat ""
	set option_overburn ""
	set burning_device ""
	refresh_cmd_line
	
}

proc FileOpen_Update {newpath} {
    catch {cd $newpath}
    .file_selection.files delete 0 end
    foreach f [lsort [glob -nocomplain *]] {
	if [file isdirectory $f] {
		append f /
	}
	.file_selection.files insert end $f
    }

    # refresh menu for current directory
    global FileOpen_CurDir selected_directory

    .file_selection.dir.menu delete 0 end
    set path [file split [pwd]]
    set FileOpen_CurDir [lindex $path end]
    set path [lreplace $path end end]
    set curpath {}
    foreach dir $path {
	lappend curpath $dir
	.file_selection.dir.menu insert 0 command -label $dir -command [list FileOpen_Update [eval file join $curpath]]
    }
    set selected_directory $newpath
}

# called function to finish open dialogue
proc FileOpen_Done {} {
	destroy .file_selection
}

# called proc when event click on open
proc FileOpen_Open {} {
    global FileOpen_Value only_one_file FileOpen_File

	if { "[.file_selection.files curselection]" != "" } {
		if { [llength [.file_selection.files curselection]] < 2 } {
			set f [.file_selection.files get [.file_selection.files curselection]]
			if [file isdirectory $f] {
				FileOpen_Update $f
			} else {
        			#puts [$widget.files curselection]
				set FileOpen_File [file join [pwd] $f]
				set only_one_file 1
				FileOpen_Done
    			}
		} else {
			foreach index_selection [.file_selection.files curselection] {
				if [file isfile [.file_selection.files get $index_selection]] {
					lappend FileOpen_File [file join [pwd] [.file_selection.files get $index_selection]]
				}
			}
			FileOpen_Done
			set FileOpen_File [concat $FileOpen_File]
		}
	}
}

# ------------------------------------------------------------------------
# Create window with needed element to select files

proc FileOpen {dir} {
	# Create main open window and name it
	toplevel .file_selection -highlightthickness 1 -highlightcolor blue -background #f5f5f5
	wm title .file_selection "Files to add ..."

	# Create message
	#label .file_selection.msg -text "File to open..." -background #f5f5f5
	#pack .file_selection.msg -side top -padx 5 -pady 5 -anchor w

	# Create menu containing the listing of directorys
	menubutton .file_selection.dir -menu .file_selection.dir.menu -textvariable FileOpen_CurDir -highlightthickness 1 -highlightbackground red -background #f5f5f5
	menu .file_selection.dir.menu -background #f5f5f5
	pack .file_selection.dir -side top -padx 5 -pady 5

	# Create listbox containing file listing and his scrollbar
	listbox .file_selection.files -width 50 -height 15 -selectmode extended -yscrollcommand ".file_selection.sb set" -background #f5f5f5
	scrollbar .file_selection.sb -orient ver -command ".file_selection.files yview"
	pack .file_selection.files -side left -fill both -expand on -padx 5 -pady 5
	pack .file_selection.sb -side left -fill y -padx 5 -pady 5

	# double click = open
	bind .file_selection.files <Double-ButtonPress-1> ".file_selection.open invoke"

	# Create Open and Cancel button
	button .file_selection.open -text Open -command "FileOpen_Open" -width 8 -highlightthickness 1 -highlightbackground red
	button .file_selection.cancel -text Cancel -command "FileOpen_Done" -width 8 -highlightthickness 1 -highlightbackground red
	pack .file_selection.open .file_selection.cancel -side bottom -fill y -padx 5 -pady 5

	# Initialize files list with current directory
	#set dir [pwd]
	FileOpen_Update $dir

	# wait selection
	global FileOpen_File
	set FileOpen_File {}
	tkwait window .file_selection
	return $FileOpen_File
}

